/* System calls, written by:
 *   David S. Miller (davem@caip.rutgers.edu)
 *   Miguel de Icaza (miguel@nuclecu.unam.mx)
 */
#ifndef _LIBC_SPARC_SYSCALL_H
#define _LIBC_SPARC_SYSCALL_H
#define _syscall0(type,name) \
type name(void) \
{ \
long __res; \
__asm__ volatile ("or %%g0, %0, %%g1\n\t" \
		  "t 0x10\n\t" \
		  "bcc 1f\n\t" \
		  "or %%g0, %%o0, %0\n\t" \
		  "sub %%g0, %%o0, %0\n\t" \
		  "1:\n\t" \
		  : "=r" (__res)\
		  : "0" (__NR_##name) \
		  : "g1"); \
if (__res >= 0) \
    return (type) __res; \
errno = -__res; \
return -1; \
}

#define _syscall1(type,name,type1,arg1) \
type name(type1 arg1) \
{ \
long __res; \
__asm__ volatile ("or %%g0, %0, %%g1\n\t" \
		  "or %%g0, %1, %%o0\n\t" \
		  "t 0x10\n\t" \
		  "bcc 1f\n\t" \
		  "or %%g0, %%o0, %0\n\t" \
		  "sub %%g0, %%o0, %0\n\t" \
		  "1:\n\t" \
		  : "=r" (__res), "=r" ((long)(arg1)) \
		  : "0" (__NR_##name),"1" ((long)(arg1)) \
		  : "g1", "o0"); \
if (__res >= 0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}

#define _syscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1,type2 arg2) \
{ \
long __res; \
__asm__ volatile ("or %%g0, %0, %%g1\n\t" \
		  "or %%g0, %1, %%o0\n\t" \
		  "or %%g0, %2, %%o1\n\t" \
		  "t 0x10\n\t" \
		  "bcc 1f\n\t" \
		  "or %%g0, %%o0, %0\n\t" \
		  "sub %%g0,%%o0,%0\n\t" \
		  "1:\n\t" \
		  : "=r" (__res), "=r" ((long)(arg1)), "=r" ((long)(arg2)) \
		  : "0" (__NR_##name),"1" ((long)(arg1)),"2" ((long)(arg2)) \
		  : "g1", "o0", "o1"); \
if (__res >= 0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}

#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("or %%g0, %0, %%g1\n\t" \
		  "or %%g0, %1, %%o0\n\t" \
		  "or %%g0, %2, %%o1\n\t" \
		  "or %%g0, %3, %%o2\n\t" \
		  "t 0x10\n\t" \
		  "bcc 1f\n\t" \
		  "or %%g0, %%o0, %0\n\t" \
		  "sub %%g0, %%o0, %0\n\t" \
		  "1:\n\t" \
		  : "=r" (__res), "=r" ((long)(arg1)), "=r" ((long)(arg2)), \
		    "=r" ((long)(arg3)) \
		  : "0" (__NR_##name), "1" ((long)(arg1)), "2" ((long)(arg2)), \
		    "3" ((long)(arg3)) \
		  : "g1", "o0", "o1", "o2"); \
if (__res>=0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}

#define _syscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4) \
{ \
long __res; \
__asm__ volatile ("or %%g0, %0, %%g1\n\t" \
		  "or %%g0, %1, %%o0\n\t" \
		  "or %%g0, %2, %%o1\n\t" \
		  "or %%g0, %3, %%o2\n\t" \
		  "or %%g0, %4, %%o3\n\t" \
		  "t 0x10\n\t" \
		  "bcc 1f\n\t" \
		  "or %%g0, %%o0, %0\n\t" \
		  "sub %%g0,%%o0, %0\n\t" \
		  "1:\n\t" \
		  : "=r" (__res), "=r" ((long)(arg1)), "=r" ((long)(arg2)), \
		    "=r" ((long)(arg3)), "=r" ((long)(arg4)) \
		  : "0" (__NR_##name),"1" ((long)(arg1)),"2" ((long)(arg2)), \
		    "3" ((long)(arg3)),"4" ((long)(arg4)) \
		  : "g1", "o0", "o1", "o2", "o3"); \
if (__res>=0) \
	return (type) __res; \
errno = -__res; \
return -1; \
} 
/*
#define _syscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5) \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5) \
{ \
long __res; \
__asm__ volatile ( \
		  "or %%g0, %1, %%o0\n\t" \
		  "or %%g0, %2, %%o1\n\t" \
		  "or %%g0, %3, %%o2\n\t" \
		  "or %%g0, %4, %%o3\n\t" \
		  "or %%g0, %5, %%o4\n\t" \
		  "or %%g0, %6, %%g1\n\t" \
		  "t 0x10\n\t" \
		  "bcc 1f\n\t" \
		  "or %%g0, %%o0, %0\n\t" \
		  "sub %%g0, %%o0, %0\n\t" \
		  "1:\n\t" \
		  : "=r" (__res) : \
		  : "0" ((long)(arg1)),"1" ((long)(arg2)), \
		    "2" ((long)(arg3)),"3" ((long)(arg4)),"4" ((long)(arg5)) \
		    "i" (__NR_##name)  \
		  : "g1", "o0", "o1", "o2", "o3", "o4"); \
if (__res>=0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}*/
#endif
